"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var PopoverDirective = (function () {
    function PopoverDirective(el) {
        this.el = el;
    }
    PopoverDirective.prototype.onMouseEnter = function () {
        this.showTitle();
    };
    PopoverDirective.prototype.onMouseLeave = function () {
        var _this = this;
        setTimeout(function () {
            _this.hideTitle();
        }, 200);
    };
    PopoverDirective.prototype.showTitle = function () {
        if (!this.titleBox) {
            var ele = document.createElement('div');
            var offset = this.options.offset || 'down';
            var empos = '';
            ele.className = 'dc-popover-tip';
            ele.style.position = 'absolute';
            ele.style.width = this.options.width || '280px';
            ele.style.paddingLeft = this.options.left || '0px';
            this.el.nativeElement.style.position = 'relative';
            this.el.nativeElement.style.zIndex = '100';
            this.el.nativeElement.style.overflow = "visible";
            this.titleBox = ele;
            if (offset === 'down') {
                ele.style.paddingTop = this.options.space || '10px';
                empos = 'transform:rotate(45deg);top: -5px;';
            }
            else {
                var height = this.titleBox.offsetHeight;
                ele.style.bottom = (height + 20) + 'px';
                ele.style.paddingBottom = this.options.space || '10px';
                empos = 'transform:rotate(-135deg);bottom:-5px;';
            }
            var htmlStr_1 = '<div style="padding:8px 12px;position:relative;background-color:#fff;width:100%;height:auto;border:1px solid #83d1ff;line-height:24px;border-radius:3px;box-shadow:0 0 10px 1px #83d1ff;">' +
                '<em style="width: 8px;height: 8px;border-left:1px solid #83d1ff;border-top:1px solid #83d1ff;display: inline-block;background-color: #fff;position: absolute;box-shadow: -1px -1px 3px #83d1ff;left:10px;' + empos + '">&nbsp;</em>' +
                '<dl style="font-size: 12px;margin:0;padding:0;color: #666;line-height: 24px;float:left;">';
            this.options.data.map(function (item) {
                htmlStr_1 += '<dt style="float:left;width: 25%;margin:0;padding:0;font-weight: bold;">' + item['key'] + '：</dt>' + '<dd style="width: 74%;float:left;text-overflow: ellipsis;overflow: hidden;white-space: nowrap;margin:0;padding:0;">' + item['value'] + '</dd>';
            });
            htmlStr_1 += '</dl><div style="clear: both"></div></div>';
            this.titleBox.innerHTML = htmlStr_1;
            this.el.nativeElement.appendChild(this.titleBox);
        }
        this.titleBox.hidden = false;
    };
    PopoverDirective.prototype.hideTitle = function () {
        this.titleBox.hidden = true;
    };
    PopoverDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: '[dcPopover]'
                },] },
    ];
    /** @nocollapse */
    PopoverDirective.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
    ]; };
    PopoverDirective.propDecorators = {
        "dcPopover": [{ type: core_1.Input },],
        "options": [{ type: core_1.Input },],
        "onMouseEnter": [{ type: core_1.HostListener, args: ['mouseenter',] },],
        "onMouseLeave": [{ type: core_1.HostListener, args: ['mouseleave',] },],
    };
    return PopoverDirective;
}());
exports.PopoverDirective = PopoverDirective;
//# sourceMappingURL=popover.directive.js.map